//+------------------------------------------------------------------+
//|                                Oasis Currency Strength Meter.mq4 |
//|                                         Copyright  2009, Oasis. |
//|                          Copyright  2009, Oasis WealthBuilders. |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Oasis WealthBuilders."
#property link      "www.oasiswealthbuilders.com"

#property indicator_chart_window
//---- input parameters
extern bool      Show_Currency_Meter_Strength = true;
//extern bool      Show_Statistic               = true;
//extern bool      Show_CS_Position             = true;
//extern bool      ShowSnR_Distance             = true;
//extern bool      ShowCandle_Direction         = true;
extern double    StrengthGap                  = 4.0;
extern int corner = 3;
//extern int xdist = 220;
extern int ydist = 15;
//--
string Currency[] ={"USD", "EUR", "GBP", "JPY", "CHF", "CAD", "NZD", "AUD"};
string   iPairs[] ={"EURUSD", "GBPUSD", "AUDUSD", "USDJPY", "USDCHF", "USDCAD", "EURAUD",
                    "EURCAD", "EURCHF", "EURGBP", "EURJPY", "GBPJPY", "GBPCHF", "NZDUSD",
                    "AUDCAD", "AUDJPY", "CHFJPY", "AUDNZD", "NZDJPY", "NZDCAD", "NZDCHF",
                    "GBPNZD", "EURNZD", "GBPCAD", "GBPAUD", "AUDCHF", "CADCHF", "CADJPY"};
//-- Trading Pairs List                   
string   tPairs[] ={"GBPJPY", "AUDJPY", "EURJPY", "USDJPY", "NZDJPY", "CHFJPY", 
                    "GBPUSD", "AUDUSD", "EURUSD", "NZDUSD", "USDCAD", "USDCHF"}; 
bool     isIBFXmini=false;                    
double   p, s1, s2, s3, r1, r2, r3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {ObjectsDeleteAll(0,OBJ_LABEL);  Comment (""); return(0);}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {ObjectsDeleteAll(0,OBJ_LABEL);  Comment (""); return(0);}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if(StringSubstr(Symbol(),6,1)=="m") 
     isIBFXmini=true;
  
   RefreshRates();
   if(Show_Currency_Meter_Strength) displayMeter();
   //if(Show_Statistic) displayHiLo();
   //if(Show_CS_Position) showCSLocation();   
   //if(ShowSnR_Distance) showSnRDist();
   //if(ShowCandle_Direction) displayCandleDirection();
   
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
double currency_strength (string currency)
{
 double currency_power=0;
 int power_level;
 int cnt=0;
 for(int i=0; i<ArraySize(iPairs); i++)
 {  
  power_level=0;
  string cur=iPairs[i];
  if (currency==StringSubstr(cur,0,3) || currency==StringSubstr(cur,3,3))
  {
   if(isIBFXmini) cur=cur+"m";
   double cur_range=(MarketInfo(cur,MODE_HIGH)-MarketInfo(cur,MODE_LOW))*MarketInfo(cur,MODE_POINT);
     if (cur_range==0) continue;
   double cur_ratio=(MarketInfo(cur,MODE_BID)-MarketInfo(cur,MODE_LOW))/cur_range*MarketInfo(cur,MODE_POINT)*100;
   
   if (cur_ratio>3)  power_level=1;
   if (cur_ratio>10) power_level=2;
   if (cur_ratio>25) power_level=3;
   if (cur_ratio>40) power_level=4;
   if (cur_ratio>50) power_level=5;
   if (cur_ratio>60) power_level=6;
   if (cur_ratio>75) power_level=7; 
   if (cur_ratio>90) power_level=8; 
   if (cur_ratio>97) power_level=9;
   
   cnt++;
   if (currency==StringSubstr(cur,3,3)) power_level=9-power_level;
   currency_power=currency_power+power_level;
  }
 }
 currency_power=currency_power/cnt;
 return (currency_power);
}

//+------------------------------------------------------------------+
void displayMeter()
{
    color textcolor;
    double objindex;
    string textname;
    int     xdist = 221;
    string textnames = "Meter";    
    objindex=0;
    
    for(int i=0; i<ArraySize(Currency); i++)
    {
     objindex++;
     textname=textnames+DoubleToStr(objindex,0);
     ObjectCreate(textname, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(textname, Currency[i],9, "Arial Bold", DimGray);
        ObjectSet(textname, OBJPROP_CORNER, corner);
        ObjectSet(textname, OBJPROP_XDISTANCE, xdist);
        ObjectSet(textname, OBJPROP_YDISTANCE, ydist+18);
     xdist=xdist-30;
    }
    
    xdist = 221;
    for(i=0; i<ArraySize(Currency); i++)
    {
     objindex++;
     textname=textnames+DoubleToStr(objindex,0);     
     textcolor=symcolor(currency_strength (Currency[i]));
     ObjectCreate(textname, OBJ_LABEL, 0, 0, 0);
        ObjectSetText(textname,DoubleToStr(currency_strength (Currency[i]),2),9, "Arial Bold", textcolor);
        ObjectSet(textname, OBJPROP_CORNER, corner);
        ObjectSet(textname, OBJPROP_XDISTANCE, xdist);
        ObjectSet(textname, OBJPROP_YDISTANCE, ydist+2);  
     xdist=xdist-30;
    }      
    ObjectCreate("Sym Line1", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("Sym Line1","__________________________________",10, "Arial Bold", White);
        ObjectSet("Sym Line1", OBJPROP_CORNER, corner);
        ObjectSet("Sym Line1", OBJPROP_XDISTANCE, 10);
        ObjectSet("Sym Line1", OBJPROP_YDISTANCE, ydist+34);    
        
    ObjectCreate("Sym Line2", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("Sym Line2","__________________________________",10, "Arial Bold", White);
        ObjectSet("Sym Line2", OBJPROP_CORNER, corner);
        ObjectSet("Sym Line2", OBJPROP_XDISTANCE, 10);
        ObjectSet("Sym Line2", OBJPROP_YDISTANCE, ydist);            
 }
//+------------------------------------------------------------------+
color symcolor(double symb)
{
 color indicolor;
 if (symb<=2) indicolor=Crimson;
 if (symb>2) indicolor=White;
 if (symb>=7) indicolor=Lime;
 return (indicolor);
}

/*/+------------------------------------------------------------------+
void displayHiLo ()
{
 int ydist=47;
 string HiLoText, HiLoTextName;
 for(int i=0; i<ArraySize(tPairs); i++)
 {
  string Sym=tPairs[i];
  if(isIBFXmini) Sym=Sym+"m";
  
  HiLoTextName="Symbol "+tPairs[i];
  HiLoText=tPairs[i];
  ObjectCreate(HiLoTextName, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(HiLoTextName,HiLoText,8, "Arial Bold", Gray);
    ObjectSet(HiLoTextName, OBJPROP_CORNER, 3);
    ObjectSet(HiLoTextName, OBJPROP_XDISTANCE, 157);
    ObjectSet(HiLoTextName, OBJPROP_YDISTANCE, ydist);  

  HiLoTextName="Spread "+Sym;  
  HiLoText=DoubleToStr(MarketInfo(Sym,MODE_SPREAD),0);
  ObjectCreate(HiLoTextName, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(HiLoTextName,HiLoText,8, "Arial", Yellow);
    ObjectSet(HiLoTextName, OBJPROP_CORNER, 3);
    ObjectSet(HiLoTextName, OBJPROP_XDISTANCE, 125);
    ObjectSet(HiLoTextName, OBJPROP_YDISTANCE, ydist);    
    
  HiLoTextName="StrengthGap "+Sym;
  double StrengthRange;
  color StrengthRangeColor;
  StrengthRange=MathAbs(currency_strength(StringSubstr(tPairs[i],0,3))-currency_strength(StringSubstr(tPairs[i],3,3)));
  if (StrengthRange>=StrengthGap) StrengthRangeColor=Lime;
  else StrengthRangeColor=Red;
  HiLoText=DoubleToStr(StrengthRange,2);
  
  ObjectCreate(HiLoTextName, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(HiLoTextName,HiLoText,8, "Arial", StrengthRangeColor);
    ObjectSet(HiLoTextName, OBJPROP_CORNER, 3);
    ObjectSet(HiLoTextName, OBJPROP_XDISTANCE, 75);
    ObjectSet(HiLoTextName, OBJPROP_YDISTANCE, ydist);         
    
  HiLoTextName="HiLo "+Sym;
  HiLoText=DoubleToStr((iHigh(Sym,1440,0)-iLow(Sym,1440,0))/MarketInfo(Sym,MODE_POINT),0);
  color HiLoTextColor;
  if (Daily_AVG (Sym)>(iHigh(Sym,1440,0)-iLow(Sym,1440,0))/MarketInfo(Sym,MODE_POINT))
   HiLoTextColor=Lime;
   else HiLoTextColor=Crimson;
  ObjectCreate(HiLoTextName, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(HiLoTextName,HiLoText,8, "Arial", HiLoTextColor);
    ObjectSet(HiLoTextName, OBJPROP_CORNER, 3);
    ObjectSet(HiLoTextName, OBJPROP_XDISTANCE, 41);
    ObjectSet(HiLoTextName, OBJPROP_YDISTANCE, ydist);     

  HiLoTextName="HiLo-AV "+Sym;     
  HiLoText=DoubleToStr(Daily_AVG (Sym),0);
  ObjectCreate(HiLoTextName, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(HiLoTextName,HiLoText,8, "Arial", White);
    ObjectSet(HiLoTextName, OBJPROP_CORNER, 3);
    ObjectSet(HiLoTextName, OBJPROP_XDISTANCE, 10);
    ObjectSet(HiLoTextName, OBJPROP_YDISTANCE, ydist);     

  ydist=ydist+12;
 }
 ObjectCreate("HiLo Line", OBJ_LABEL, 0, 0, 0);
  ObjectSetText("HiLo Line","________________________________",8, "Arial Bold", White);
  ObjectSet("HiLo Line", OBJPROP_CORNER, 3);
  ObjectSet("HiLo Line", OBJPROP_XDISTANCE, 10);
  ObjectSet("HiLo Line", OBJPROP_YDISTANCE, ydist+1);
  
 ObjectCreate("HiLo Title", OBJ_LABEL, 0, 0, 0);
  ObjectSetText("HiLo Title","PAIRS     SPREAD  RANGE  HiLo  D-Av",8, "Arial Bold", White);
  ObjectSet("HiLo Title", OBJPROP_CORNER, 3);
  ObjectSet("HiLo Title", OBJPROP_XDISTANCE, 10);
  ObjectSet("HiLo Title", OBJPROP_YDISTANCE, ydist+2); 

 ObjectCreate("HiLo Info", OBJ_LABEL, 0, 0, 0);
  ObjectSetText("HiLo Info"," www.oasiswealthbuilders.com",7, "Arial Bold", Yellow);
  ObjectSet("HiLo Info", OBJPROP_CORNER, 3);
  ObjectSet("HiLo Info", OBJPROP_XDISTANCE, 13);
  ObjectSet("HiLo Info", OBJPROP_YDISTANCE, 5);   
}

//+------------------------------------------------------------------+
int Daily_AVG (string symbolAvg)
{
 int R1=0,R5=0,R10=0,R20=0,RAvg=0,i=0;
 R1 =  (iHigh(symbolAvg,PERIOD_D1,1)-iLow(symbolAvg,PERIOD_D1,1))/MarketInfo(symbolAvg,MODE_POINT);
 for(i=1;i<=5;i++)  R5=R5+(iHigh(symbolAvg,PERIOD_D1,i)-iLow(symbolAvg,PERIOD_D1,i))/MarketInfo(symbolAvg,MODE_POINT);
 for(i=1;i<=10;i++) R10=R10+(iHigh(symbolAvg,PERIOD_D1,i)-iLow(symbolAvg,PERIOD_D1,i))/MarketInfo(symbolAvg,MODE_POINT);
 for(i=1;i<=20;i++) R20=R20+(iHigh(symbolAvg,PERIOD_D1,i)-iLow(symbolAvg,PERIOD_D1,i))/MarketInfo(symbolAvg,MODE_POINT);
 R5 = R5/5;
 R10 = R10/10;
 R20 = R20/20;
 RAvg  = (R1+R5+R10+R20)/4;  
 return (RAvg);
}
//+------------------------------------------------------------------+
void showCSLocation ()
{
 int ydist=47;
 string StatusText, StatusTextName;
 for(int i=0; i<ArraySize(tPairs); i++)
 double Open0, Close0;
 color Statuscolor;
 {
  string Sym=tPairs[i];
  if(isIBFXmini) Sym=Sym+"m";
  Open0= iOpen(Sym,PERIOD_M15,0);//--Current Bar open for TF M15
  Close0= iClose(Sym,PERIOD_M15,0);//-- Current bar close for TF M15
  SymFiboPivot (Sym);
   
  if (Close0>r3) {StatusText=">R3"; Statuscolor=Lime;}
  if (Close0<r3) {StatusText="R2-R3"; Statuscolor=Green;}
  if (Close0<r2) {StatusText="R1-R2"; Statuscolor=DarkGreen;}
  if (Close0<r1) {StatusText="Pivot-R1"; Statuscolor=DimGray;}
  if (Close0<p)  {StatusText="S1-Pivot"; Statuscolor=DimGray;}  
  if (Close0<s1) {StatusText="S2-S1"; Statuscolor=Maroon;}
  if (Close0<s2) {StatusText="S3-S2"; Statuscolor=Crimson;}
  if (Close0<s3) {StatusText="<S3"; Statuscolor=Red;}
 
  if (Open0<r3 && Close0>=r3) {StatusText="X R3"; Statuscolor=Magenta;}
  if (Open0<r2 && Close0>=r2) {StatusText="X R2"; Statuscolor=Magenta;}
  if (Open0<r1 && Close0>=r1) {StatusText="X R1"; Statuscolor=Magenta;}  

  if (Open0>s1 && Close0<=s1) {StatusText="X S1"; Statuscolor=Magenta;}
  if (Open0>s2 && Close0<=s2) {StatusText="X S2"; Statuscolor=Magenta;}
  if (Open0>s3 && Close0<=s3) {StatusText="X S3"; Statuscolor=Magenta;}
 
  StatusTextName="Status "+Sym;

  ObjectCreate(StatusTextName, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(StatusTextName,StatusText,8, "Arial Bold", Statuscolor);
    ObjectSet(StatusTextName, OBJPROP_CORNER, 3);
    ObjectSet(StatusTextName, OBJPROP_XDISTANCE, 220);
    ObjectSet(StatusTextName, OBJPROP_YDISTANCE, ydist);  
    
  ydist=ydist+12; 
 }
   ObjectCreate("StatusTitle", OBJ_LABEL, 0, 0, 0);
    ObjectSetText("StatusTitle","CS(M15)",8, "Arial Bold", White);
    ObjectSet("StatusTitle", OBJPROP_CORNER, 3);
    ObjectSet("StatusTitle", OBJPROP_XDISTANCE, 220);
    ObjectSet("StatusTitle", OBJPROP_YDISTANCE, ydist);  
}
//+------------------------------------------------------------------+
void SymFiboPivot (string sympivot)
{
 double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
 ArrayCopyRates(rates, sympivot, PERIOD_D1);
 
 if(DayOfWeek() == 1)
 {
  if(TimeDayOfWeek(iTime(sympivot,PERIOD_D1,1)) == 5)
  {
   yesterday_close = rates[1][4];
   yesterday_high = rates[1][3];
   yesterday_low = rates[1][2];
  }
  else
  {
   for(int d = 5;d>=0;d--)
   {
    if(TimeDayOfWeek(iTime(sympivot,PERIOD_D1,d)) == 5)
    {
     yesterday_close = rates[d][4];
     yesterday_high = rates[d][3];
     yesterday_low = rates[d][2];
    }
   }  
  }
 }
 else
 {
  yesterday_close = rates[1][4];
  yesterday_high = rates[1][3];
  yesterday_low = rates[1][2];
 }
//---- Calculate Pivots
 double R = yesterday_high - yesterday_low;//range
 p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
 r3 = p + (R * 1.000);
 r2 = p + (R * 0.618);
 r1 = p + (R * 0.382);
 s1 = p - (R * 0.382);
 s2 = p - (R * 0.618);
 s3 = p - (R * 1.000);
}
//+------------------------------------------------------------------+
void showSnRDist ()
{
 string iSnR[]={"GBPJPY", "GBPUSD", "EURJPY"};
 string text1, text2;
 double dist1, dist2;
 int ydist=30;
 RefreshRates();
 for(int i=0; i<ArraySize(iSnR); i++)
 {
  string Sym=iSnR[i];
  if(isIBFXmini) Sym=Sym+"m";
  double CS=iClose(Sym,NULL,0);
  SymFiboPivot (iSnR[i]);
  
  if(CS>=r3)
  {
   dist1=(CS-r3)/MarketInfo(Sym,MODE_POINT);
   text1=DoubleToStr(dist1,0)+"pips > R3";
   text2="";
  }
  if(CS<r3 && CS>=r2)
  {
   dist1=(r3-CS)/MarketInfo(Sym,MODE_POINT);
   dist2=(CS-r2)/MarketInfo(Sym,MODE_POINT);
   text1=DoubleToStr(dist1,0)+"pips < R3";
   text2=DoubleToStr(dist2,0)+"pips > R2";
  }
  if(CS<r2 && CS>=r1)
  {
   dist1=(r2-CS)/MarketInfo(Sym,MODE_POINT);
   dist2=(CS-r1)/MarketInfo(Sym,MODE_POINT);
   text1=DoubleToStr(dist1,0)+"pips < R2";
   text2=DoubleToStr(dist2,0)+"pips > R1";
  }
  if(CS<r1 && CS>=p)
  {
   dist1=(r1-CS)/MarketInfo(Sym,MODE_POINT);
   dist2=(CS-p)/MarketInfo(Sym,MODE_POINT);
   text1=DoubleToStr(dist1,0)+"pips < R1";
   text2=DoubleToStr(dist2,0)+"pips > Pivot";
  }  
  if(CS<p && CS>=s1)
  {
   dist1=(p-CS)/MarketInfo(Sym,MODE_POINT);
   dist2=(CS-s1)/MarketInfo(Sym,MODE_POINT);
   text1=DoubleToStr(dist1,0)+"pips < Pivot";
   text2=DoubleToStr(dist2,0)+"pips > S1";
  }  
  if(CS<s1 && CS>=s2)
  {
   dist1=(s1-CS)/MarketInfo(Sym,MODE_POINT);
   dist2=(CS-s2)/MarketInfo(Sym,MODE_POINT);
   text1=DoubleToStr(dist1,0)+"pips < S1";
   text2=DoubleToStr(dist2,0)+"pips > S2";
  } 
  if(CS<s2 && CS>=s3)
  {
   dist1=(s2-CS)/MarketInfo(Sym,MODE_POINT);
   dist2=(CS-s3)/MarketInfo(Sym,MODE_POINT);
   text1=DoubleToStr(dist1,0)+"pips < S2";
   text2=DoubleToStr(dist2,0)+"pips > S3";
  }   
  if(CS<s3)
  {
   dist1=(CS-s3)/MarketInfo(Sym,MODE_POINT);
   text1=DoubleToStr(dist1,0)+"pips < S3";
   text2="";
  }     
  string SnRText="SnRPairName"+Sym;
  ObjectCreate(SnRText, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(SnRText,Sym,8, "Arial Bold", Gray);
    ObjectSet(SnRText, OBJPROP_CORNER, 1);
    ObjectSet(SnRText, OBJPROP_XDISTANCE, 170);
    ObjectSet(SnRText, OBJPROP_YDISTANCE, ydist); 

  SnRText="SnRDist1"+Sym;
    ObjectCreate(SnRText, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(SnRText,text1,8, "Arial Bold", White);
    ObjectSet(SnRText, OBJPROP_CORNER, 1);
    ObjectSet(SnRText, OBJPROP_XDISTANCE, 90);
    ObjectSet(SnRText, OBJPROP_YDISTANCE, ydist); 
    
  SnRText="SnRDist2"+Sym;
    ObjectCreate(SnRText, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(SnRText,text2,8, "Arial Bold", White);
    ObjectSet(SnRText, OBJPROP_CORNER, 1);
    ObjectSet(SnRText, OBJPROP_XDISTANCE, 10);
    ObjectSet(SnRText, OBJPROP_YDISTANCE, ydist);     
  ydist=ydist+10; 
  
 } 
}
//+------------------------------------------------------------------+
void displayCandleDirection()
{
 color CandleArrow1, CandleArrow2;
 int ydist=85;
 string textM15,text_H1;
 for(int i=ArraySize(tPairs)-1; i>-1; i--)
 {
  string Sym=tPairs[i];
  if(isIBFXmini) Sym=Sym+"m";
  double CSopen15 = iOpen(Sym,PERIOD_M15,0);
  double CSclose15 = iClose(Sym,PERIOD_M15,0);
  double CSopenH1 = iOpen(Sym,PERIOD_H1,0);
  double CScloseH1 = iClose(Sym,PERIOD_H1,0);
    
  if(CSopen15<CSclose15) 
  { textM15=""; CandleArrow1=Lime; }
   else { textM15=""; CandleArrow1=Red; }
  if(CSopenH1<CScloseH1) 
  { text_H1=""; CandleArrow2=Lime; }
   else { text_H1=""; CandleArrow2=Red; }

  string CandleSymName="CandleDirection "+tPairs[i];
  ObjectCreate(CandleSymName, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(CandleSymName,tPairs[i],8, "Arial Bold", Gray);
    ObjectSet(CandleSymName, OBJPROP_CORNER, 1);
    ObjectSet(CandleSymName, OBJPROP_XDISTANCE, 55);
    ObjectSet(CandleSymName, OBJPROP_YDISTANCE, ydist); 
        
  CandleSymName="Candle_M15 "+tPairs[i];
  ObjectCreate(CandleSymName, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(CandleSymName,textM15,8, "Wingdings", CandleArrow1);
    ObjectSet(CandleSymName, OBJPROP_CORNER, 1);
    ObjectSet(CandleSymName, OBJPROP_XDISTANCE, 30);
    ObjectSet(CandleSymName, OBJPROP_YDISTANCE, ydist);  
    
  CandleSymName="Candle_H1"+tPairs[i];
  ObjectCreate(CandleSymName, OBJ_LABEL, 0, 0, 0);
    ObjectSetText(CandleSymName,text_H1,8, "Wingdings", CandleArrow2);
    ObjectSet(CandleSymName, OBJPROP_CORNER, 1);
    ObjectSet(CandleSymName, OBJPROP_XDISTANCE, 10);
    ObjectSet(CandleSymName, OBJPROP_YDISTANCE, ydist);         

  ydist= ydist+12;
 }
 ObjectCreate("CandleDirection", OBJ_LABEL, 0, 0, 0);
  ObjectSetText("CandleDirection","M15  H1",8, "Arial Bold", White);
  ObjectSet("CandleDirection", OBJPROP_CORNER, 1);
  ObjectSet("CandleDirection", OBJPROP_XDISTANCE, 5);
  ObjectSet("CandleDirection", OBJPROP_YDISTANCE, 72); 
} */